#include "dtr_rts_set.h"

struct termios tio;                         // Zugriff um HUPCK Bit loeschen zu koennen

int serstatus, serhandle;


void ser_setDTR(void)
{
  serstatus &= ~TIOCM_DTR;
  ioctl(serhandle, TIOCMSET, &serstatus);      // ... und neuen Status setzen
}

void ser_clrDTR(void)
{
  serstatus |= TIOCM_DTR;
  ioctl(serhandle, TIOCMSET, &serstatus);      // ... und neuen Status setzen
}

void ser_setRTS(void)
{
  serstatus &= ~TIOCM_RTS;
  ioctl(serhandle, TIOCMSET, &serstatus);      // ... und neuen Status setzen
}

void ser_clrRTS(void)
{
  serstatus |= TIOCM_RTS;
  ioctl(serhandle, TIOCMSET, &serstatus);      // ... und neuen Status setzen
}


void ser_open(char *portname)
{
  tcgetattr(serhandle, &tio);
  tio.c_cflag &= ~HUPCL;                         // HUPCL - Bit loeschen
  tcsetattr(serhandle, TCSANOW, &tio);

  ioctl(serhandle, TIOCMGET, &serstatus);        // Status Serielle Schnittstelle

  if ((serhandle = open(portname,O_RDWR)) < 0)
  {
    printf("Failure: %s not present\n",portname);
    exit(1);
  }
  tcgetattr(serhandle, &tio);
  tio.c_cflag &= ~HUPCL;                         // HUPCL - Bit loeschen
  tcsetattr(serhandle, TCSANOW, &tio);

  ioctl(serhandle, TIOCMGET, &serstatus);        // Status Serielle Schnittstelle

}

void ser_close(void)
{
  close(serhandle);
}

/*
//   Main - Demo for usage

int main(void)
{
  int   i;
  char  serport[] = "/dev/ttyUSB0";

  ser_open(&serport[0]);

  ser_setRTS();
  ser_setDTR();

  ser_close();                              // Device schliessen
}

*/
